//---------------------------------------------------------------------------

#include <vcl.h>
#include <iostream>
#include <iterator>
#include <set>
#include <algorithm>

#include <conio.h> //  getch()

#include "assoiter.hpp"

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;


std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

template <class T>
inline void PRINT_ELEMENTS (const T& coll, const char* optcstr="")
{
  typename T::const_iterator pos;
  std::cout << ToRus(optcstr);
  for (pos=coll.begin(); pos!=coll.end(); ++pos) {
    std::cout <<*pos <<' ';
  }
  std::cout << std::endl;
}

int main(int argc, char* argv[])
{

  set<int> coll;   

  //     coll
  // -  
  asso_insert_iterator<set<int> > iter(coll);

  //      
  *iter = 1;
  iter++;
  *iter = 2;
  iter++;
  *iter = 3;

  PRINT_ELEMENTS(coll," : ");

  //     coll   
  // -  
  asso_inserter(coll) = 44;
  asso_inserter(coll) = 55;

  PRINT_ELEMENTS(coll,"   : ");

  //     
  int vals[] = { 33, 67, -4, 13, 5, 2 };
  copy (vals, vals+(sizeof(vals)/sizeof(vals[0])),  // 
        asso_inserter(coll));                       // 

  PRINT_ELEMENTS(coll,"   : ");

  getch();
  return 0;
}

//---------------------------------------------------------------------------